//                              -*- Mode: C++ -*- 
// DataWrap.cc --- 
//

#include "DataWrap.h"

unsigned int DataWrap::msSortIndex = 0;


float& DataWrap::operator[]( unsigned int index )
{ 
  //  cout<<"DataWrap::operator[]"<<endl;
  if( index >= mCoord.size() ) {
    int diff =  index - mCoord.size();
    for( int i=0; i<=diff; i++)
      mCoord.push_back( 0 );
  }
  return mCoord[index];
}


const float& DataWrap::operator[]( unsigned int index ) const
{ 
  //  cout<<"DataWrap::operator[] const"<<endl;
  if( index >= mCoord.size() ) {
    cerr << "DataWrap::[" << index
	 <<"] -> value does not exist!  Size=" 
	 << size() << endl;
    abort();
  }
  return mCoord[index];
}


ostream& operator<<( ostream& out, const DataWrap& theData ) 
{
  theData.output( out );
  return out;
}

ostream& DataWrap::output( ostream& out ) const {

  vector<float>::const_iterator i = mCoord.begin();
  out << "Coordinates: (";
  if ( i != mCoord.end() ) {
    out << *i;
    for ( i++ ; i != mCoord.end(); i++)
      out << ", " << *i;
  }
  else out << " ";
  out << ")  " << flush;
  return out;
}  
