//                              -*- Mode: C++ -*- 
// DensityPlotW.h
// Copyright  1999 Laboratoire de Biologie Informatique et Thorique.
// Author           : Etienne Tourigny-Manning
// Created On       : Wed Dec  8 14:38:53 1999
// Last Modified By : 
// Last Modified On : 
// Update Count     : 0
// Status           : Unknown.
// 

#ifndef __DensityPlotW_h_
#define __DensityPlotW_h_

#include "PlotW.h"
#include "ValueSelectW.h"

#include <algo.h>


class DensityPlotW : public PlotW
{
  Q_OBJECT

protected:

  ValueSelectW *mVarSelect;
  
  static float msCutoff;
  static float msVar;

  float mVar;
  float mFact;
  
  int mDataIndex;  //index des donnees dans les DataWrap

//    bool mDirtyNormal;


  float Normal( float x, float mu, float sigma )
    { float d = x-mu; return mFact * exp( -d*d/(2*sigma*sigma) ); }

public:
  
  // LIFECYCLE ------------------------------------------------------------

  DensityPlotW( QWidget *parent=0, const char *name=0 ); 
  ~DensityPlotW( void ) {}


  // METHODS --------------------------------------------------------------

  virtual void Reset( ) { PlotW::Reset(); SetVar( ); }  

  // Assigne mVar et mFact avec une variance par defaut, msVar
  // ne pas utiliser 
  void SetVar( float nVar = msVar )
    { if(nVar==0) return; mVar = nVar; 
    mFact = (1/sqrt(2*M_PI*mVar*mVar)); }

protected:

  virtual void UpdateScales( );

  virtual void MyPaint( QPainter *painter, PaintConfig &config );

  virtual void Pick( int x, int y );
  virtual void Pick( int x1, int x2, int y1, int y2 );
  virtual void DisplayPick( int x1, int x2, int y1, int y2 );

  // Slots ----------------------------------------------------------------

public slots:
  
  void ShowVarSlider( );
  void ChangeVar( float v ); 
  
//  protected:

//    signals:
  
//    void changeVarSignal( const char *str );
  
//  public slots:

//  void DensityPlotW::changeVar( const char *str )
//  {
//    sscanf( str, "%f", &mVar );
//    mFact = (1/sqrt(2*M_PI*mVar*mVar));
//  }
//    void changeVar( const char *str );
//    void compute( void ){
//      mWidth = -1; update();
//    }
//    void sliderUpdate( int v ){
//      mVar = (float)v / 50;
//      if ( mCenter->size() < 200 ){
//        compute();
//      }
//      char tmpBuf[ 256 ];
//      sprintf( tmpBuf, "%f", mVar );
//      emit changeVarSignal( tmpBuf );
//    }

};

#endif

