//                              -*- Mode: C++ -*- 
// ValueSelectW.cc --- 
// 

#include "ValueSelectW.h"

#include <iostream.h>
#include <math.h>
#include <values.h>
#include <time.h>

ValueSelectW::ValueSelectW( QWidget *parent, const char *name,
		  float min, float max, float init, float st )
  : QWidget( parent, name )  
{
  //init
  mLazySlider = false;  
  setCaption( name ); 
  setMinimumSize( 250, 75 );
//   setMaximumSize( 250, 75 );
  mMin = min;
  mMax = max;
  mDefValue = init;
  mValue = mTmpValue = mSliderValue = mEditValue = mDefValue;
  mStretch = st;

  //components
  mSlider = new QSlider( mMin*mStretch, mMax*mStretch, 0, 10, QSlider::Horizontal, this );
  mSlider->setValue( mDefValue*mStretch );
  mSlider->setTickmarks( QSlider::Below );
  mSlider->setFocusPolicy( StrongFocus );
  
  mLabel = new QLabel( this ); 
  mLabel->setAlignment( AlignHCenter ); 
  mLabel->setMinimumWidth( 75 );
  
  mEdit = new QLineEdit( this );
   mEdit->setMinimumWidth( 75 );

  mDefault = new QPushButton( "Default", this );
  mDefault->setMinimumWidth( 75 );

  //layout
  mLayout = new QVBoxLayout( this, 5 );
  mRow1 = new QHBoxLayout( );
  mRow2 = new QHBoxLayout( );
  mLayout->addLayout( mRow1 );
  mLayout->addLayout( mRow2 );
  mRow1->addWidget( mSlider );
  mRow2->addWidget( mLabel );
  mRow2->addWidget( mEdit );
  mRow2->addSpacing( 20 );
  mRow2->addWidget( mDefault );

  //ici car components actifs mais signaux non connectes
  SetValue();

  //connexions
  connect( mDefault, SIGNAL( pressed() ), 
	   this, SLOT( SetToDefault() ) );

  connect( mSlider, SIGNAL( sliderMoved( int ) ), 
	   this, SLOT( SetSliderValue( int ) ) );
  connect( mSlider, SIGNAL( sliderReleased() ), 
	   this, SLOT( SetToSlider() ) );
  connect( mSlider, SIGNAL( valueChanged( int ) ), 
	   this, SLOT( SetSliderValue( int ) ) );

  connect( mEdit, SIGNAL( textChanged( const QString& ) ), 
	   this, SLOT( SetEditValue( const QString& ) ) );
  connect( mEdit, SIGNAL( returnPressed() ), 
	   this, SLOT( SetToEdit() ) );

}


ValueSelectW::~ValueSelectW( )
{
  delete mLayout;
  delete mRow1;
  delete mRow2;
  delete mSlider;
  delete mLabel;
  delete mEdit;
  delete mDefault;
}


void ValueSelectW::SetEditValue( const QString &str )  //SLOT
{
  float val;
  bool ok;

  //   sscanf( str, "%f", &val );
  val = str.toFloat( &ok );
//   cout <<"read "<<val<<" min="<<mMin<<endl;

  if ( ok ) mEditValue = val;
  else mEditValue = mDefValue;

}
  

void ValueSelectW::SetValue( float val ) //SLOT
{ 
//   if ( val >= mMin && val <= mMax ) {
    mTmpValue = val; 
    SetValue();
//   }
//   else
//     cout << "ValueSelectW: " << val << " out of bounds!" << endl;
}


void ValueSelectW::SetValue( )
{ 
  mValue = mTmpValue; 
  char* str = new char[96];
  sprintf( str, "  Value \n %.3f ", mValue );
//   cout<<"set value to: "<<mValue<<endl;
  mLabel->setText( str ); 
  emit ValueChanged( mValue );
}
