//                              -*- Mode: C++ -*- 
// ValueSelectW.h
// Copyright  2000 Laboratoire de Biologie Informatique et Thorique.
// Author           : Etienne Tourigny-Manning
// Created On       : Tue Jan 11 17:44:57 2000
// Last Modified By : 
// Last Modified On : 
// Update Count     : 0
// Status           : Unknown.
// 


#ifndef __ValueSelectW_h_
#define __ValueSelectW_h_

#include <stdio.h>
#include <math.h>
#include <values.h>


#include <qlayout.h>
#include <qslider.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qstring.h>

class ValueSelectW : public QWidget
{
  Q_OBJECT

protected: 

  bool mLazySlider;       
  float mMin, mMax, mStretch;  //params pour slider
  float mValue, mDefValue;
  float mSliderValue, mEditValue, mTmpValue;
  QVBoxLayout *mLayout;
  QHBoxLayout *mRow1;
  QHBoxLayout *mRow2;
  QSlider *mSlider;
  QLabel *mLabel;
  QLineEdit *mEdit;
  QPushButton *mDefault;

public:

  ValueSelectW( QWidget *parent=0, const char *name=0, 
	   float min=0, float max=100, float init=0, float st=50 ); 
  ~ValueSelectW( );


 signals:
   void ValueChanged( float val );


public slots:

  void SetToDefault( ) { SetValue( mDefValue ); }
  void SetValue( float val );

protected slots:

  void SetSliderValue( int val ) 
    { mSliderValue = val/mStretch; if(!mLazySlider) SetToSlider();}
  void SetEditValue( const QString &str );
  void SetToSlider( )  { SetValue( mSliderValue ); } 
  void SetToEdit( )   { SetValue( mEditValue ); }
  void SetValue( );
};

#endif
