// lplot.cc        -*- mode: c++ -*-
// Copyright  1999 Laboratoire de Biologie Informatique et Thorique.
// Author           : Patrick Gendron <gendrop@vertigo.IRO.UMontreal.CA>
// Created on       : Wed Apr 12 10:03:23 2000
// Modified by      : 
// Modified on      : 
// Update count     : 0
// Status           : Unknown.

#include <iostream.h>
#include <fstream>

#include <qapplication.h>

#include "DataWrap.h"
#include "ScatterPlotW.h"

int main (int argc, char* argv[])
{
  if ( argc < 2 ) {
    cerr << "Usage: lplot <files>" << endl;
    exit( EXIT_SUCCESS );
  }

  QApplication app( argc, argv );
  ScatterPlotW scatter;

  char tmpStr[ 4096 ];
  char *tmpPtr;
  float xVal, yVal;
  ifstream in;

   srand (0);

  for ( int i=1; i<argc; i++) {
    in.open(argv[i]);
    if( in.is_open() ) {
      in >> tmpStr >> xVal >> yVal; 
      if ( !in.eof() ) {
	float r = (float)rand ()*255/RAND_MAX;
	float g = (float)rand ()*255/RAND_MAX;
	float b = (float)rand ()*255/RAND_MAX;
	scatter.AddSerie (QPen ( QColor (r,g,b)));
      }
      while( !in.eof() ) {
	tmpPtr = new char[ strlen( tmpStr )+1 ];
	strcpy( tmpPtr, tmpStr );
	scatter.AddData( new DataOutput<char*> (tmpPtr, xVal, yVal));
	in >> tmpStr >> xVal >> yVal; 
      }
    }
    in.close();
  }

  scatter.resize( 600, 300 );
  sprintf (tmpStr,"Line plot - ",argv[1]);
  scatter.setCaption (tmpStr);
  scatter.show(); 

  app.setMainWidget( &scatter );
  app.exec();
  return EXIT_SUCCESS;
}
