// zplot.cc        -*- mode: c++ -*-
// Copyright  1999 Laboratoire de Biologie Informatique et Thorique.
// Author           : Patrick Gendron <gendrop@vertigo.IRO.UMontreal.CA>
// Created on       : Wed Apr 19 10:30:41 2000
// Modified by      : 
// Modified on      : 
// Update count     : 0
// Status           : Unknown.

#include <iostream.h>
#include <fstream.h>
#include <glob.h>

#include <qapplication.h>

#include "DataWrap.h"
#include "DensityPlotW.h"

int main (int argc, char* argv[])
{
  if (argc==1) {
    cerr << "Usage: zplot <ffe windows>" << endl;
    exit (EXIT_FAILURE);
  }
  
  ifstream in;
  char tmpStr[4096];
  float x;
  char filenames[256];

  QApplication app (argc, argv);
  DensityPlotW win;
  
  win.SetVar (0.2);
  
  for (int k=1; k<argc; ++k) {

    vector< float > values;
    vector< float > meanvalues;
    vector< float > means;
    vector< float > devs;
    
    float r = (float)rand ()*255/RAND_MAX;
    float g = (float)rand ()*255/RAND_MAX;
    float b = (float)rand ()*255/RAND_MAX;
    win.AddSerie (QPen ( QColor (r,g,b)));
    
    glob_t globBuf;
    globBuf.gl_offs = 0;
    glob (argv[k], GLOB_DOOFFS, NULL, &globBuf);
    if (globBuf.gl_pathc == 0) {
      cerr << "Error: File " << argv[k] << " not found" << endl; 
      exit (EXIT_FAILURE);
    }
    for (int j=0; j<globBuf.gl_pathc; j++ ) {
      cout << globBuf.gl_pathv[j] << endl;
      in.open (globBuf.gl_pathv[j]);
      if (in.is_open()) {    
	in >> x;
	values.push_back (x);

	cout << "Value = " << values.back () << endl;

	means.push_back (0.0);
	devs.push_back (0.0);
	in >> x;
	meanvalues.clear ();
	while ( !in.eof () ) {
	  meanvalues.push_back (x);
	  means.back () += x;
	  in >> x;
	}   
	means.back () /= meanvalues.size ();
	
	cout << "Mean = " << means.back () << endl;
	
	for (int j=0; j<meanvalues.size (); ++j) {
	  devs.back () += (meanvalues[j]-means.back ()) * 
                          (meanvalues[j]-means.back ());
	}
	
	devs.back () /= meanvalues.size ();
	devs.back () = sqrt (devs.back ());
	
	cout << "Standard deviation = " << devs.back () << endl;
	cout << "Z-Score = " << -(values.back () - means.back ())/devs.back () << endl;
      }
      in.close ();
    }

    for (int j=0; j<values.size (); ++j) {
      win.AddData(new DataOutput<char*>( "j", -(values[j] - means[j])/devs[j] ));
    }
  }
  win.resize( 600, 300 );
  win.setCaption( "Z-Score plot" );
  win.show();
  //   win.ShowVarSlider();
  
  app.setMainWidget( &win );
  app.exec();
  
  return EXIT_SUCCESS;

}
